package com.jisco.dynamicweight.dynamicworktly.controller;

import cn.hutool.core.lang.Assert;
import com.jisco.dynamicweight.dynamicworktly.model.DynamicWorkTly;
import com.jisco.dynamicweight.dynamicworktly.service.IDynamicWorkTlyService;
import com.jisco.dynamicweight.dynamicworkupdata.model.DynamicWorkUpdata;
import com.jisco.dynamicweight.util.ExcelUtil;
import com.jisco.dynamicweight.util.UserUtil;
import com.steerinfo.framework.controller.BaseRESTfulController;
import com.steerinfo.framework.controller.RESTfulResult;
import com.steerinfo.framework.service.pagehelper.PageList;
import com.steerinfo.framework.utils.collection.ListUtils;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletResponse;
import java.io.IOException;
import java.math.BigDecimal;
import java.util.Arrays;
import java.util.Date;
import java.util.HashMap;
import java.util.List;

/**
 * DynamicWorkTly RESTful接口：
 * @author generator
 * @version 1.0-SNAPSHORT 2022-01-25 05:01
 * 类描述
 * 修订历史：
 * 日期：2022-01-25
 * 作者：generator
 * 参考：
 * 描述：DynamicWorkTly RESTful接口
 * @see null
 * @Copyright 湖南视拓信息技术股份有限公司. All rights reserved.
 */
@RestController
@RequestMapping("/${api.version}/dynamicworktlys")
public class DynamicWorkTlyController extends BaseRESTfulController {

    @Autowired
    IDynamicWorkTlyService dynamicWorkTlyService;

    @ApiOperation(value="获取列表", notes="分页查询")
    @ApiImplicitParams({
        @ApiImplicitParam(name = "pageNum", value = "查询页数", required = false, dataType = "Integer"),
        @ApiImplicitParam(name = "pageSize", value = "每页记录数", required = false, dataType = "Integer")
    })
    //@RequiresPermissions("dynamicworktly:view")
    @GetMapping(value = "/")
    public RESTfulResult list(@RequestParam HashMap parmas,Integer pageNum, Integer pageSize){
        PageList<DynamicWorkTly> list = dynamicWorkTlyService.queryForPage(parmas, pageNum, pageSize);
        return success(list);
    }

    @ApiOperation(value="获取列表", notes="分页模糊查询")
    @ApiImplicitParams({
        @ApiImplicitParam(name = "pageNum", value = "查询页数", required = false, dataType = "Integer"),
        @ApiImplicitParam(name = "pageSize", value = "每页记录数", required = false, dataType = "Integer")
    })
    //@RequiresPermissions("dynamicworktly:view")
    @GetMapping(value = "/like/")
    public RESTfulResult listLike(@RequestParam HashMap parmas,Integer pageNum, Integer pageSize){
        PageList<DynamicWorkTly> list = dynamicWorkTlyService.queryLikeForPage(parmas, pageNum, pageSize);
        return success(list);
    }
    
    @ApiOperation(value="创建", notes="根据DynamicWorkTly对象创建")
    @ApiImplicitParam(name = "dynamicWorkTly", value = "详细实体dynamicWorkTly", required = true, dataType = "DynamicWorkTly")
    //@RequiresPermissions("dynamicworktly:create")
    @PostMapping(value = "/")
    public RESTfulResult add(@RequestBody DynamicWorkTly model){
        Assert.isTrue(model.getRq() != null, "日期不能为空");
        Assert.isTrue(model.getWeight() != null && model.getWeight().compareTo(new BigDecimal(0)) > 0, "脱硫液重量必须大于0");
        model.setValidFlag("1");
//        model.setCreateManNo(UserUtil.getCurrentUserId());
//        model.setCreateManName(UserUtil.getCurrentUserName());
        model.setCreateTime(new Date());
        DynamicWorkTly dynamicWorkTly = dynamicWorkTlyService.add(model);
        return success(dynamicWorkTly);
    }

    @ApiOperation(value="获取详细信息", notes="根据url的id来获取详细信息")
    @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String")
    //@RequiresPermissions("dynamicworktly:view")
    @GetMapping(value = "/{id}")
    public RESTfulResult get(@PathVariable String id){
        DynamicWorkTly dynamicWorkTly = dynamicWorkTlyService.getById(id);
        return success(dynamicWorkTly);
    }

    @ApiOperation(value="更新详细信息", notes="根据url的id来指定更新对象，并根据传过来的dynamicWorkTly信息来更新详细信息")
    @ApiImplicitParams({
        @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String"),
        @ApiImplicitParam(name = "dynamicWorkTly", value = "详细实体dynamicWorkTly", required = true, dataType = "DynamicWorkTly")
    })
    //@RequiresPermissions("dynamicworktly:update")
    @PutMapping(value = "/{id}", produces  = "application/json;charset=UTF-8")
    public RESTfulResult update(@PathVariable String id, @RequestBody DynamicWorkTly model){
        Assert.isTrue(model.getRq() != null, "日期不能为空");
        Assert.isTrue(model.getWeight() != null && model.getWeight().compareTo(new BigDecimal(0)) > 0, "脱硫液重量必须大于0");
//        model.setUpdateManNo(UserUtil.getCurrentUserId());
//        model.setUpdateManName(UserUtil.getCurrentUserName());
        model.setUpdateTime(new Date());
        model.setId(id);
        DynamicWorkTly dynamicWorkTly = dynamicWorkTlyService.modify(model);
        return success(dynamicWorkTly);
    }

    @ApiOperation(value="删除", notes="根据url的id来指定删除对象")
    @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String")
    //@RequiresPermissions("dynamicworktly:delete")
    @DeleteMapping(value = "/{id}")//String
    public RESTfulResult delete(@PathVariable String id){
    	List<String> list = Arrays.asList(id.split(","));
    	if(ListUtils.isNotEmpty(list)) {
	    	List<String> ids = ListUtils.convertList(list);
			  dynamicWorkTlyService.delete(ids);
    	}
      return success();
    }

    @ApiOperation(value = "导出Excel", notes = "导出Excel")
    @PostMapping(value = "/exportExcel")//String
    public void exportExcel(HttpServletResponse response, @RequestParam HashMap parmas) throws IOException {
        List<DynamicWorkUpdata> list = dynamicWorkTlyService.query(parmas);
        ExcelUtil.exportExcel(response, list, DynamicWorkUpdata.class, "脱硫液");
    }

}
